<?php
/*
Extension Name: IDShare
Extension Url: http://lussumo.com/addons/
Description: Allows all members of a forum to more easily share their IDS and Usernames on other systems
Version: 0.1
Author: Scott Rubin
Author Url: http://www.apreche.net
 */

//do not allow direct visiting, keep out the riff-raff
if( !defined('IN_VANILLA') ) exit();

// Configuration Variables

// these are the fields permitted by the administrator
$IDShareConf_Permitted = array('AIM','MSN','Jabber','Flickr','Skype','Twittr','Pownce','Facebook','MySpace','DeviantArt','LiveJournal','Digg','Wii','Mario Kart DS');

// Strings
//
// Change the text on the personal information page
$Context->Dictionary['AddCustomInformationNotes'] = 'The IDShare extension is enabled on this forum. If you configure certain custom attributes in your profile, that information will be available to other forum members on the IDShare page. Contact your forum administrator for more information';

$Context->Dictionary['ID_Title'] = 'IDShare';
$Context->Dictionary['ID_User'] = 'Username';
$Context->Dictionary['ID_Icon'] = 'Avatar';
$Context->Dictionary['ID_Value'] = 'Value';
$Context->Dictionary['ID_Edit'] = 'Edit your info';

// THE CODE BEGINS

// This code adds the tab in the menu
if(isset($Menu) && $Context->Session->UserID > 0 ) {
	$Menu->AddTab($Context->GetDefinition('ID_Title'), $Context->GetDefinition('ID_Title'), GetUrl($Configuration, 'extension.php', '', '', '', '', 'PostBackAction=IDShare'), $Attributes = '', $Position = '35', $ForcePosition = '35');
}

// inside this box put the code that will run when the user is logged in and visiting extension.php
if(in_array($Context->SelfUrl, array('extension.php')) && $Context->Session->UserID > 0) {

	class IDShare extends PostBackControl{

		// Store all of the user data in this variable
		var $UserData;
		// list of all existing user attributes

		// constructor
		function IDShare( &$Context ) {

			// set variables
			$this->UserData = array();

			// name for Vanilla delegation
			$this->Name = 'IDShare';
			// these are the valid postback actions
			$this->ValidActions = array('IDShare','IDShareFilter');
			// call the constructor
			$this->Constructor( $Context );

			// load up the data only if necessary
			if( $this->IsPostBack && ($this->PostBackAction == 'IDShareFilter') ){
				// use the Vanila Sql builder thing
				$sql = $Context->ObjectFactory->NewContextObject($Context, 'SqlBuilder');
				$sql->SetMainTable('User','u');
				$sql->AddSelect( array('UserID', 'Name', 'Icon', 'Attributes'), 'u' );
				$sql->AddWhere( '','Attributes', '','', '!=' );
				$result = $Context->Database->Select($sql, 'IDShare', 'IDShare', 'ERROR: IDShare SQL ');

				// lowercase the list of permitted fields
				$permitted = array();
				foreach( $GLOBALS['IDShareConf_Permitted'] as $value ){
					$permitted[] = strtolower( $value );
				}
				// extract every user's serialized attributes into a usable format
				while( $row = $Context->Database->GetRow($result) ){

					$attributes = array();
					$temp = UnserializeAssociativeArray($row['Attributes']);
					foreach( $temp as $attribute ){
						$attribute['Label'] = strtolower( $attribute['Label'] );
						if( in_array( $attribute['Label'], $permitted ) ){
							// add attribute to this user
							$attributes[$attribute['Label']] = $attribute['Value'];
						}
					}
					// add the data to the UserData of this instance
					$row['Attributes'] = $attributes;
					$this->UserData[] = $row;
				}
			}

			// allow people to attach delegates to this control
			$this->CallDelegate('Constructor');
		}

		// default IDShare page to render
		function defaultRender() {


			// render just the form and the pulldown menu
			echo '<form method="post" action="extension.php?PostBackAction=IDShareFilter">';
			echo '<select name="searchAttribute" onChange="this.form.submit();">';
			// a blank entry first
			echo "<option>--</option>";
			// now all the other options
			foreach( $GLOBALS['IDShareConf_Permitted'] as $att ){
				$attlower = strtolower( $att );
				echo "<option value=\"{$attlower}\" ";
				if( !empty( $_POST['searchAttribute'] ) && ( $attlower == strtolower($_POST['searchAttribute']) ) ){
					echo "selected=\"selected\" ";
				}
				echo ">" . $att . "</option>";
			}
			echo '</select>';
			// we don't need a submit button when we have Javascript
			//echo '<input type="submit" value="Search" />';
			echo '</form>';
			// put a link to take users to their profile editing page
			/*
			echo '<a href="account.php?PostBackAction=Identity">';
			echo $this->Context->GetDefinition('ID_Edit');
			echo '</a>';
			 */



		}

		// IDShare page to render when looking for a particular field
		function filterRender() {

			// but also render the results
			if( !empty( $_POST['searchAttribute'] ) ){
				$sattr = $_POST['searchAttribute'];

				/* 
				 	// if an attribute is a URI or email address, linkify it
				 	$tattr = $user['Attributes'][$sattr];
					if( preg_match( $tattr, REGEX_URI ) ){
						$tattr = "<a href=\"{$tattr}\">{$tattr}</a>";
					}elseif( preg_match( $user['Attributes'][$sattr], REGEX_EMAIL ) ) {
						$tattr = "<a href=\"mailto:{$tattr}\">{$tattr}</a>";
					}
					$user['Attributes'][$sattr] = $tattr;
				 */
				

				echo '<table>';
				// table header
				echo '<tr><td><b>';
				echo $this->Context->GetDefinition('ID_Icon');
				echo '</b></td><td><b>';
				echo $this->Context->GetDefinition('ID_User');
				echo '</b></td><td><b>';
				echo $this->Context->GetDefinition('ID_Value');
				echo '</b></td></tr>';
				// table contents
				foreach( $this->UserData as $user ){
					if( !empty( $user['Attributes'][$sattr] ) ){
						echo '<tr><td>'; 
						echo "<img src=\"{$user['Icon']}\" />";
						echo '</td><td>';
						// link to user's name to their profile
						echo "<a href=\"account.php?u={$user['UserID']}\">";
						echo $user['Name'];
						echo '</a>';
						echo "</td><td>";
						echo( $user['Attributes'][$sattr] );
						echo '</td></tr>';
					}
				}
				echo '</table>';
			}
		}


		// actually print out the HTML for the IDShare page
		function Render() {

			// allow delegates to render before my stuff
			$this->CallDelegate('PreRender');

			//always render the pulldown menu
			$this->defaultRender();
			// render the results when there are results to render
			if( $this->PostBackAction == 'IDShareFilter' ){
				$this->filterRender();
			}

			// allow delegates to render after my stuff
			$this->CallDelegate( 'PostRender' );
		}
	}

	// actually instantiate the class and get the business going on
	if(in_array(ForceIncomingString("PostBackAction", ""), array('IDShare', 'IDShareFilter'))) {
		$Head->AddStyleSheet('extensions/IDShare/style.css');
		$Context->PageTitle = $Context->GetDefinition('ID_Title');
		$Menu->CurrentTab = 'IDShare';
		$IDShare = $Context->ObjectFactory->NewContextObject($Context, 'IDShare');
		$Page->AddRenderControl($IDShare, $Configuration["CONTROL_POSITION_BODY_ITEM"]);
	}
}
?>
